//
//  MovementAnimationsViewController.m
//  MovementAnimations
//
//  Created by Brad Larson on 2/14/2010.
//

#import "MovementAnimationsViewController.h"
#import <QuartzCore/QuartzCore.h>

@implementation MovementAnimationsViewController

#pragma mark -
#pragma mark Initialization and teardown

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	startingViewFrame = viewToAnimate.frame;
	startingPosition = viewToAnimate.layer.position;
    [super viewDidLoad];
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

#pragma mark -
#pragma mark Button methods

- (IBAction)viewMoveAnimation:(id)sender;
{
	CGRect currentViewFrame = viewToAnimate.frame;
	currentViewFrame.origin.x = currentViewFrame.origin.x + 100.0f;

	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:1];	
	[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
		
	viewToAnimate.frame = currentViewFrame;
	
	[UIView commitAnimations];
	
//	[UIView animateWithDuration:1 animations:^{ viewToAnimate.frame = currentViewFrame; }];
//	[UIView animateWithDuration:1 animations:^{ viewToAnimate.frame = currentViewFrame; }  completion:^(BOOL finished){ NSLog(@"Animation completed"); }];
}

- (IBAction)viewScaleAnimation:(id)sender;
{
	CGAffineTransform scaleTransform = CGAffineTransformMakeScale(2.0f, 2.0f);
	
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:1.0f];	
	[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
	
	viewToAnimate.transform = scaleTransform;
	
	[UIView commitAnimations];
}

- (IBAction)caMoveAnimation:(id)sender;
{
	CABasicAnimation *moveAnimation = [CABasicAnimation animationWithKeyPath:@"position"];
	moveAnimation.duration = 1.0f;
	moveAnimation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];

	moveAnimation.removedOnCompletion = NO;
	moveAnimation.fillMode = kCAFillModeForwards;
	
	CGPoint currentPosition = viewToAnimate.layer.position;
	CGPoint newPosition = CGPointMake(currentPosition.x + 100.0f, currentPosition.y);
	moveAnimation.toValue = [NSValue valueWithCGPoint:newPosition];
	[viewToAnimate.layer addAnimation:moveAnimation forKey:@"animateMovement"];
	
	// If you want to have the new position match what you are animating to, use the following:
	//	[viewToAnimate.layer addAnimation:moveAnimation forKey:@"position"];
//	viewToAnimate.layer.position = newPosition;
	

	/*
	 // Do this using CATransactions 
	 

	[UIView beginAnimations:nil context:NULL];
	
	[CATransaction begin];
	[CATransaction setValue:[NSNumber numberWithFloat:1.0f] forKey:kCATransactionAnimationDuration];
	[CATransaction setAnimationTimingFunction:[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut]];

	CGPoint currentPosition = viewToAnimate.layer.position;
	viewToAnimate.layer.position = CGPointMake(currentPosition.x + 100.0f, currentPosition.y);
	
	[CATransaction commit];
	
	[UIView commitAnimations];*/
}

- (IBAction)caPathMoveAnimation:(id)sender;
{
	CAKeyframeAnimation *pathAnimation = [CAKeyframeAnimation animationWithKeyPath:@"position"];
	pathAnimation.duration = 1.0f;
	pathAnimation.calculationMode = kCAAnimationPaced;

	CGPoint currentPosition = viewToAnimate.layer.position;
	CGPoint endPoint = CGPointMake(currentPosition.x + 100.0f, currentPosition.y - 50.0f);
	CGMutablePathRef curvedPath = CGPathCreateMutable();
	CGPathMoveToPoint(curvedPath, NULL, currentPosition.x, currentPosition.y);
	CGPathAddCurveToPoint(curvedPath, NULL, endPoint.x, currentPosition.y, endPoint.x, currentPosition.y, endPoint.x, endPoint.y);
	pathAnimation.path = curvedPath;
	CGPathRelease(curvedPath);
	
	pathAnimation.fillMode = kCAFillModeForwards;
	pathAnimation.removedOnCompletion = NO;
		
	[viewToAnimate.layer addAnimation:pathAnimation forKey:@"animateMovementUsingPath"];
}

- (IBAction)restartAnimation:(id)sender;
{
	viewToAnimate.transform = CGAffineTransformIdentity;
	[viewToAnimate.layer removeAllAnimations];
	viewToAnimate.frame = startingViewFrame;
}

@end
